/*
 * 开机奖励
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class OpenRewardController : BaseController
    {
        public OpenRewardController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 开机奖励列表

        /// <summary>
        /// 根据条件查询开机奖励列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(OpenReward data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            return View();
        }

        #endregion

        #region 根据条件查询开机奖励列表

        /// <summary>
        /// 开机奖励列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(OpenReward data, string MakerCode, string RealName, string CheckStatusSelect, string CreateDateData, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("BrandId", "0"); //品牌
            Fields.Add("TopUserId", "0"); //顶级创客

            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(MakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + MakerCode + "')";
            }
            //创客名称
            if (!string.IsNullOrEmpty(RealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + RealName + "')";
            }
            //验证和同步账户状态
            if(!string.IsNullOrEmpty(CheckStatusSelect))
            {
                condition += " and CheckStatus=" + CheckStatusSelect;
            }
            if (!string.IsNullOrEmpty(CreateDateData))
            {
                string[] datelist = CreateDateData.Split(new string[] { " - " }, StringSplitOptions.None);
                string start = datelist[0];
                string end = datelist[1];
                condition += " and CreateDate>='" + start + " 00:00:00' and CreateDate<='" + end + " 23:59:59'";
            }

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("OpenReward", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["BrandId"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["BrandId"].ToString()));
                int UserId = int.Parse(dic["UserId"].ToString());
                Users user = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["MakerCode"] = user.MakerCode;
                dic["RealName"] = user.RealName;
                int TopUserId = int.Parse(dic["TopUserId"].ToString());
                Users tuser = db.Users.FirstOrDefault(m => m.Id == TopUserId) ?? new Users();
                dic["TopMakerCode"] = tuser.MakerCode;
                dic["TopRealName"] = tuser.RealName;
                int RewardType = int.Parse(dic["RewardType"].ToString());
                if (RewardType == 0) dic["RewardType"] = "无开机奖励";
                if (RewardType == 1) dic["RewardType"] = "开机直接奖励";
                if (RewardType == 2) dic["RewardType"] = "开机间接奖励";
            }
            return Json(obj);
        }

        #endregion

        #region 增加开机奖励

        /// <summary>
        /// 增加或修改开机奖励信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加开机奖励

        /// <summary>
        /// 增加或修改开机奖励信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(OpenReward data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("OpenReward", Fields, 0);
            AddSysLog(data.Id.ToString(), "OpenReward", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改开机奖励

        /// <summary>
        /// 增加或修改开机奖励信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            OpenReward editData = db.OpenReward.FirstOrDefault(m => m.Id == Id) ?? new OpenReward();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改开机奖励

        /// <summary>
        /// 增加或修改开机奖励信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(OpenReward data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("OpenReward", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "OpenReward", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除开机奖励信息

        /// <summary>
        /// 删除开机奖励信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "OpenReward", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("OpenReward", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "OpenReward", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("OpenReward", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "OpenReward", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("OpenReward", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("OpenReward", Sort, Id);

            AddSysLog(Id.ToString(), "OpenReward", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.OpenReward.Add(new OpenReward()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "OpenReward", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(OpenReward data, string MakerCode, string RealName, string CheckStatusSelect)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("CreateDate", "3"); //交易时间
            Fields.Add("BrandId", "0"); //品牌
            Fields.Add("TopUserId", "0"); //顶级创客

            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(MakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + MakerCode + "')";
            }
            //创客名称
            if (!string.IsNullOrEmpty(RealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + RealName + "')";
            }
            //验证和同步账户状态
            if(!string.IsNullOrEmpty(CheckStatusSelect))
            {
                condition += " and CheckStatus=" + CheckStatusSelect;
            }

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("OpenReward", Fields, "Id desc", "0", 1, 20000, condition, "TradeDate,UserId,TopUserId,BrandId,RewardType,CreditTradeAmt,DebitTradeAmt,CreditRewardAmount,DebitRewardAmount,RewardMerCount,CheckStatus", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["BrandId"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["BrandId"].ToString()));
                int UserId = int.Parse(dic["UserId"].ToString());
                Users user = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["MakerCode"] = user.MakerCode;
                dic["RealName"] = user.RealName;
                int TopUserId = int.Parse(dic["TopUserId"].ToString());
                Users tuser = db.Users.FirstOrDefault(m => m.Id == TopUserId) ?? new Users();
                dic["TopMakerCode"] = tuser.MakerCode;
                dic["TopRealName"] = tuser.RealName;
                int RewardType = int.Parse(dic["RewardType"].ToString());
                if (RewardType == 0) dic["RewardType"] = "无开机奖励";
                if (RewardType == 1) dic["RewardType"] = "开机直接奖励";
                if (RewardType == 2) dic["RewardType"] = "开机间接奖励";
                int CheckStatus = int.Parse(dic["CheckStatus"].ToString());
                if (CheckStatus == 0) dic["CheckStatus"] = "初始";
                if (CheckStatus == 1) dic["CheckStatus"] = "已验证和同步";
                dic.Remove("UserId");
                dic.Remove("TopUserId");
            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("MakerCode", "奖励创客编号");
            ReturnFields.Add("RealName", "奖励创客名称");
            ReturnFields.Add("TradeDate", "达标日期");
            ReturnFields.Add("TopMakerCode", "顶级创客编号");
            ReturnFields.Add("TopRealName", "顶级创客名称");
            ReturnFields.Add("BrandId", "产品名称");
            ReturnFields.Add("RewardType", "奖励类型");
            ReturnFields.Add("CreditTradeAmt", "贷记卡交易总金额(元)");
            ReturnFields.Add("DebitTradeAmt", "借记卡交易总金额(元)");
            ReturnFields.Add("CreditRewardAmount", "贷记卡交易奖励金额(元)");
            ReturnFields.Add("DebitRewardAmount", "借记记卡交易奖励金额(元)");
            ReturnFields.Add("RewardMerCount", "达标商户数");
            ReturnFields.Add("CreateDate", "创建时间");
            ReturnFields.Add("CheckStatus", "同步状态");
            result.Add("Fields", ReturnFields);
            AddSysLog("0", "OpenReward", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
